clear all 
clc 
close all

%Résolution de l'équation u_t+f(u)_x=0 par une méthode RK1-DG sur [a,b] muni de conditions aux limites
% u_x(a,t)=u_x(b,t)=0 et de la donnée initiale u(x,0)=u_0(x), 0<=t<=T

a=-1;b=1;T=0.7;t=0;
N=30;% nombre d'élement
M=5;% nombre d'élément pour la quadrature numérique
k=0;%degré d'approximation
h=(b-a)/(N+1); % pas de la subdivision
xx=a:h:b; % maillage en espace
xx2=a:0.01:b; % maillage en espace pour tracer uniquement
ug=1;ud=2;x0=(b+a)/2;
u0=@(x)(ug*(x<x0)+ud*(x>=x0)); %donnée initiale
%u0=@(x)(exp(-10*(x-x0).^2)); %donnée initiale
% INITIALISATION: projection de la donnée initiale sur la base phi^i_j
U=projection(k,N,M,xx,u0);
for l=1:length(xx2)
    yy(l)=uh(xx2(l),xx,U,N,k);
end
%plot(xx2,yy,'o',xx2,u0(xx2))
%title('t=',num2str(t))
%pause()

cpt=1;
t=0; 
while (t<T)
    [dt,c]=deltat(U,xx,N,k);
    t=t+dt;
    Unew = dg(U,N,M,k,xx,dt,c);
    U=Unew;

for l=1:length(xx2)
    yy(l)=uh(xx2(l),xx,U,N,k);
    yex(l)=uex(xx2(l),t,ug,ud,x0);
end
plot(xx2,yy,'-o',xx2,u0(xx2),xx2,yex)
title('t=',num2str(t))
axis([a b 0 3])
F(cpt) = getframe(gcf) ;
drawnow
cpt=cpt+1;
pause(0.0001)
end


 writerObj = VideoWriter(['simup',num2str(k),'.avi']);
  writerObj.FrameRate = 30;
  % set the seconds per image
% open the video writer
open(writerObj);
% write the frames to the video
for i=1:length(F)
    % convert the image to a frame
    frame = F(i) ;    
    writeVideo(writerObj, frame);
end
% close the writer object
close(writerObj);




